﻿Imports Microsoft.Activities.SecurityPack.Designers

Namespace X509SecurityTokenSample
	<Designer(GetType(GetX509SecurityTokenDesigner))>
	Public Class GetX509SecurityToken
		Inherits GetSecurityToken
		Public Sub New()
			FindType = X509FindType.FindBySubjectName
			StoreLocation = StoreLocation.CurrentUser
			StoreName = StoreName.My
		End Sub

		Public Property Certificate() As InArgument(Of X509Certificate2)
		Public Property FindType() As X509FindType
		Public Property StoreLocation() As StoreLocation
		Public Property FindValue() As InArgument(Of String)
		Public Property StoreName() As StoreName

		Protected Overrides Sub Execute(ByVal context As NativeActivityContext)
			Dim targetCert As X509Certificate2 = Nothing
			If Me.Certificate IsNot Nothing Then targetCert = Me.Certificate.Get(context)
			If targetCert Is Nothing Then
				Dim store = New X509Store(StoreName, StoreLocation)
				Try
					store.Open(OpenFlags.ReadOnly)
					Dim col = store.Certificates.Find(FindType, FindValue.Get(context), False)
                    If col.Count > 0 Then
                        targetCert = col(2)
                    End If
                    'Use first certificate mathing the search criteria
                Finally
                    If store IsNot Nothing Then store.Close()
                End Try
			End If
			If targetCert Is Nothing Then Throw New InvalidOperationException("No certificate found using the specified find criteria.")
			' enlist the token as a flow token
			MyBase.EnlistSecurityToken(context, New X509SecurityToken(targetCert))
		End Sub
	End Class
End Namespace
