﻿Imports System.Security.Cryptography.X509Certificates
Imports Microsoft.IdentityModel.Configuration
Imports TestWorkflowService
Imports Microsoft.IdentityModel.Tokens
Imports System.ServiceModel.Security
Imports System.IdentityModel.Selectors

Imports Microsoft.IdentityModel.Protocols.WSTrust
Imports System.ServiceModel
Imports Microsoft.IdentityModel.SecurityTokenService

Namespace BasicSTS
    Friend Class Program
        Shared Sub Main(ByVal args() As String)
            Dim pfx As New X509Certificate2("localhost.pfx", "a")

            Dim stsConfig As New SecurityTokenServiceConfiguration("urn:localhost", New X509SigningCredentials(pfx)) With
            {.SecurityTokenService = GetType(CustomSecurityTokenService)}

            ' host STS as WS-Trust endpoint.
            Dim stsHost As New WSTrustServiceHost(stsConfig, New Uri("http://localhost:9000/STS"))
            Dim bid = New WSHttpBinding("AnnonyForCertificate")
            stsHost.AddServiceEndpoint(GetType(IWSTrustFeb2005SyncContract), bid, "")
            stsHost.Credentials.ServiceCertificate.Certificate = pfx
            stsHost.Open()

            Console.WriteLine("STS running...")
            For Each ep In stsHost.Description.Endpoints
                Console.WriteLine(ep.ListenUri)
            Next ep
            Console.ReadLine()
            stsHost.Close()
        End Sub
    End Class
End Namespace
