﻿Imports System.IdentityModel.Selectors
Imports System.Security.Cryptography.X509Certificates
Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports System.ServiceModel.Security

'Standard Code Based WCF Service.
Namespace WCFService
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Dim sh = New ServiceHost(GetType(PingService))
			sh.Credentials.ServiceCertificate.Certificate = New X509Certificate2("localhost.pfx", "a")
			sh.Credentials.UserNameAuthentication.CustomUserNamePasswordValidator = New SimpleUserNamePasswordValidator()
			sh.Credentials.UserNameAuthentication.UserNamePasswordValidationMode = UserNamePasswordValidationMode.Custom

			sh.Open()
			Console.WriteLine("Host ready. Endpoints: ")
			For Each ep In sh.Description.Endpoints
				Console.WriteLine(ep.ListenUri)
			Next ep
			Console.ReadLine()
			sh.Close()
		End Sub
	End Class

	Public Class SimpleUserNamePasswordValidator
		Inherits UserNamePasswordValidator
		Public Overrides Sub Validate(ByVal userName As String, ByVal password As String)
			Console.WriteLine("[Success]: {0} authenticated.", userName)
		End Sub
	End Class



    <ServiceContract()>
 Friend Class PingService
        <OperationContract()>
        Public Sub Ping()
            Dim remoteEndpoint =
                TryCast(OperationContext.Current.IncomingMessageProperties(RemoteEndpointMessageProperty.Name), 
                    RemoteEndpointMessageProperty)
            Console.WriteLine("Ping from {0}:{1}", remoteEndpoint.Address, remoteEndpoint.Port)
        End Sub
    End Class
End Namespace
