﻿Namespace Extensions.Utilities

    Public Module Diagnostics

        Private _trace As TraceSource
        Sub New()
            Trace = New TraceSource("WorkflowSecurityPack", SourceLevels.All)
            Trace.Listeners.Clear()
            Trace.Listeners.Add(New ConsoleTraceListener())
        End Sub

        Public Property Trace() As TraceSource
            Get
                Return _trace
            End Get
            Set(ByVal value As TraceSource)
                _trace = value
            End Set
        End Property

        <System.Runtime.CompilerServices.Extension()>
        Public Sub TraceWarning(ByVal source As TraceSource,
                                ByVal message As String)
            source.TraceEvent(TraceEventType.Warning, 0, message, Nothing)
        End Sub

        <System.Runtime.CompilerServices.Extension()>
        Public Sub TraceWarning(ByVal source As TraceSource,
                                ByVal format As String,
                                ByVal ParamArray args() As Object)
            source.TraceEvent(TraceEventType.Warning, 0, format, args)
        End Sub

        <System.Runtime.CompilerServices.Extension()>
        Public Sub TraceError(ByVal source As TraceSource,
                              ByVal message As String)
            source.TraceEvent(TraceEventType.Error, 0, message, Nothing)
        End Sub

        <System.Runtime.CompilerServices.Extension()>
        Public Sub TraceError(ByVal source As TraceSource,
                              ByVal format As String,
                              ByVal ParamArray args() As Object)
            source.TraceEvent(TraceEventType.Error, 0, format, args)
        End Sub

    End Module
End Namespace
