﻿Imports System.IdentityModel.Tokens
Imports System.Security.Cryptography.X509Certificates
Imports System.ServiceModel.Activities
Imports System.ServiceModel.Security
Imports Extensions.Utilities
Imports Microsoft.IdentityModel.Configuration
Imports Microsoft.IdentityModel.Tokens

Namespace WorkflowServiceFacade
    Friend Class Program
        Shared Sub Main(ByVal args() As String)
            Dim wfsh = New WorkflowServiceHost(New WFServiceFacade(), New Uri("http://localhost:8000/WFFacade"))

            Dim configuration = New ServiceConfiguration With {
                .ServiceCertificate = New X509Certificate2("WFServiceFacade.pfx", "a"),
                .CertificateValidationMode = X509CertificateValidationMode.None,
                .SaveBootstrapTokens = True,
                .IssuerNameRegistry = New CertBasedIssuerNameRegistry()}
            configuration.AudienceRestriction.AllowedAudienceUris.Add(wfsh.BaseAddresses.First())
            FederatedServiceCredentials.ConfigureServiceHost(wfsh, configuration)

            wfsh.Open()
            Console.WriteLine(wfsh.WriteEndpoints())
            Console.ReadLine()
            wfsh.Close()
        End Sub
    End Class

	Friend Class CertBasedIssuerNameRegistry
        Inherits IssuerNameRegistry

		Public Overrides Overloads Function GetIssuerName(ByVal securityToken As SecurityToken) As String
			Dim cert = TryCast(securityToken, X509SecurityToken)
			If cert IsNot Nothing Then
				Return cert.Certificate.Issuer
			End If
			Return Nothing
		End Function
	End Class

End Namespace
